Index: boost/graph/detail/d_ary_heap.hpp
===================================================================
--- boost/graph/detail/d_ary_heap.hpp	(revision 63753)
+++ boost/graph/detail/d_ary_heap.hpp	(working copy)
@@ -92,6 +92,8 @@
     public:
     typedef typename Container::size_type size_type;
     typedef Value value_type;
+    typedef typename boost::property_traits<DistanceMap>::value_type key_type;
+    typedef DistanceMap key_map;
 
     d_ary_heap_indirect(DistanceMap distance,
                         IndexInHeapPropertyMap index_in_heap,
@@ -164,6 +166,10 @@
       verify_heap();
     }
 
+    DistanceMap keys() const {
+      return distance;
+    }
+
     private:
     Compare compare;
     Container data;
